<?php

//Including all extensions
require_once dirname(__FILE__) . '/../../config/config.php';
require_once dirname(__FILE__) . '/../../config/language/' . $language;
require_once dirname(__FILE__) . '/../../src/plugins/class.phpmailer.php';
require_once dirname(__FILE__) . '/../../src/plugins/class.smtp.php';
require_once dirname(__FILE__) . '/../../src/plugins/timeconvert.php';
require_once dirname(__FILE__) . '/../../src/plugins/Mobile_Detect.php';
require_once dirname(__FILE__) . '/../../resources/class/encrypt.class.php';

$table_ftp = 'droppy_ftp';

$get_ftp_settings = $mysqli->query("SELECT * FROM $table_ftp");

if(!$get_ftp_settings) {
	//NO TABLES FOUND
}
else
{
	while($row = $get_ftp_settings->fetch_assoc()) {
		//Get the FTP server IP from the database
		$ftp_server = $row['server'];

		//Get the FTP username from the database
		$ftp_username = $row['username'];

		//Get the FTP password from the database
		$ftp_password = $row['password'];

		//Get the FTP upload path
		$ftp_path = $row['path'];

        //Get the type of FTP connection
        $ftp_type = $row['ftp_type'];

        //Login type
        $ftp_login = $row['ftp_login'];

        //SFTP settings
        $sftp_passphrase = $row['sftp_passphrase'];
        $sftp_key = $row['sftp_key'];
    }
}

if (!function_exists('loginFTP')) {
    function loginFTP()
    {
        global $ftp_server, $ftp_username, $ftp_password, $ftp_type, $ftp_login, $sftp_passphrase, $sftp_key;

        if ($ftp_type == 'ftp') {
            // set up basic connection
            $conn_id = ftp_connect($ftp_server);

            // login with username and password
            $login = ftp_login($conn_id, $ftp_username, $ftp_password);
        } elseif ($ftp_type == 'sftp') {
            set_include_path(dirname(__FILE__) . '/sftp');

            include('Net/SSH2.php');
            include('Net/SFTP.php');
            include('Crypt/RSA.php');

            //if login type is password and username
            if ($ftp_login == 'password') {
                //Make the connection
                $conn_id = new Net_SFTP($ftp_server);
                if (!$conn_id->login($ftp_username, $ftp_password)) {
                    error_log('Login Failed');
                }
            } //If login type is username and key
            elseif ($ftp_login == 'key') {
                $conn_id = new Net_SFTP($ftp_server);
                $key = new Crypt_RSA();

                $key->setPassword($sftp_passphrase);

                //Load the key
                $key->loadKey($sftp_key);

                //Make connection
                if (!$conn_id->login($ftp_username, $key)) {
                    error_log('Login Failed');
                }
            }
        }

        return $conn_id;
    }

    //Function that uploads the files to the FTP server
    function uploadFTP($local_file, $filename)
    {
        global $ftp_path, $ftp_type;

        $ftp_conn = loginFTP();

        if ($ftp_type == 'ftp') {
            if (ftp_put($ftp_conn, $ftp_path . $filename, $local_file, FTP_BINARY)) {
                return true;
            }
        } elseif ($ftp_type == 'sftp') {
            if ($ftp_conn->put($ftp_path . $filename, $local_file, NET_SFTP_LOCAL_FILE)) {
                return true;
            }
        }
    }

    //Function that deletes the files from the FTP server
    function deleteFTP($file, $ftp_conn)
    {
        global $ftp_path, $ftp_type;

        if ($ftp_type == 'ftp') {
            if (ftp_delete($ftp_conn, $ftp_path . $file)) {
                return true;
            }
        } elseif ($ftp_type == 'sftp') {
            if ($ftp_conn->delete($ftp_path . $file)) {
                return true;
            }
        }
    }

    function downloadFTP($filename, $download_filename, $ftp_conn, $encrypt, $passphrase)
    {
        global $ftp_path, $ftp_server, $ftp_username, $ftp_password, $ftp_type;

        set_time_limit(0);

        ob_start();

        if ($ftp_type == 'ftp') {
            header('Content-Type: application/octet-stream');
            header('Content-Transfer-Encoding: binary');
            header('Content-Disposition: attachment; filename="' . $download_filename . '"');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Content-Length: ' . ftp_size($ftp_conn, $ftp_path . $filename)); // provide file size

            if ($encrypt) {
                $encrypter = new Encrypt();

                $file = $encrypter->decryptfile('ftp://' . $ftp_username . ':' . $ftp_password . '@' . $ftp_server . '/' . $ftp_path . $filename, $passphrase);

                while (!feof($file)) {
                    print(@fread($file, 1024 * 8));
                    ob_flush();
                    flush();
                }
            } else {
                while (ob_get_level()) ob_end_clean();
                readfile('ftp://' . $ftp_username . ':' . $ftp_password . '@' . $ftp_server . '/' . $ftp_path . $filename);
            }

            //readfile('ftp://' . $ftp_username . ':' . $ftp_password . '@' . $ftp_server . '/' . $ftp_path . $filename);
        } elseif ($ftp_type == 'sftp') {
            header('Content-Type: application/octet-stream');
            header('Content-Transfer-Encoding: binary');
            header('Content-Disposition: attachment; filename="' . $download_filename . '"');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Content-Length: ' . $ftp_conn->size($ftp_path . $filename)); // provide file size

            //echo $output;*/
            echo $ftp_conn->get($ftp_path . $filename);
        }
    }
}
?>