<?php
require_once dirname(__FILE__) . '/config.php';

$current_dir = basename(dirname(__FILE__));

echo '
<div class="form-panel" style="overflow:hidden;">
    <h4 class="mb"><i class="fa fa-angle-right"></i> FTP Settings</h4>
    <form class="form-horizontal style-form" method="post" action="../plugins/' . $current_dir . '/action.php">
      <input type="hidden" name="action" value="settings">
      <div class="form-group">
        <label class="col-sm-2 col-sm-2 control-label">Server host</label>
        <div class="col-sm-10">
            <input type="text" class="form-control" name="ftp_server" placeholder="Server host" value="' . $ftp_server . '">
        </div>
      </div>
      <div class="form-group">
        <label class="col-sm-2 col-sm-2 control-label">Username</label>
        <div class="col-sm-10">
            <input type="text" class="form-control" name="ftp_username" placeholder="Username" value="' . $ftp_username . '">
        </div>
      </div>
      <div class="form-group">
        <label class="col-sm-2 col-sm-2 control-label">External Path</label>
        <div class="col-sm-10">
            <input type="text" class="form-control" name="ftp_path" placeholder="External path" value="' . $ftp_path . '">
            <i>The path where the files should be placed on the FTP server, leave empty to place the files in the main directory that is defined by the FTP server</i>
        </div>
      </div>
      
      <div class="form-group">
        <label class="col-sm-2 col-sm-2 control-label">FTP Type</label>
        <div class="col-sm-10">
          <select class="form-control" name="ftp_type" id="ftp_type">
            <option value="ftp" '.($ftp_type == 'ftp' ? 'selected' : '').'>FTP</option>
            <option value="sftp" '.($ftp_type == 'sftp' ? 'selected' : '').'>SFTP (No support for file encryption)</option>
          </select>
        </div>
      </div>
      
      <div id="ftp" style="'.($ftp_type == 'ftp' ? 'display:block' : 'display:none').'">
        <div class="form-group">
            <label class="col-sm-2 col-sm-2 control-label">Password</label>
            <div class="col-sm-10">
                <input type="password" class="form-control" name="ftp_password" placeholder="Password">
            </div>
        </div>
      </div>
      
      <div id="sftp" style="'.($ftp_type == 'sftp' ? 'display:block' : 'display:none').'">
         <div class="form-group">
            <label class="col-sm-2 col-sm-2 control-label">SFTP Login method</label>
            <div class="col-sm-10">
              <p><span style="color: red;">NOTE</span> At this moment the SFTP method does not support encrypted files, downloading/uploading will fail when this has been enabled.</p>
              <select class="form-control" name="sftp_login" id="sftp_login">
                <option value="password" '.($ftp_login == 'password' ? 'selected' : '').'>Password</option>
                <option value="key" '.($ftp_login == 'key' ? 'selected' : '').'>Private key (RSA)</option>
              </select>
            </div>
          </div>
          
         <div id="sftp_password" style="'.($ftp_login == 'password' ? 'display:block' : 'display:none').'">
            <div class="form-group">
                <label class="col-sm-2 col-sm-2 control-label">Password</label>
                <div class="col-sm-10">
                    <input type="password" class="form-control" name="sftp_password" placeholder="Password">
                </div>
            </div>
         </div>
         <div id="sftp_key" style="'.($ftp_login == 'key' ? 'display:block' : 'display:none').'">
             <div class="form-group">
                <label class="col-sm-2 col-sm-2 control-label">SFTP Passphrase (leave empty if no passphrase is required)</label>
                <div class="col-sm-10">
                    <input type="password" class="form-control" name="sftp_passphrase" placeholder="Passphrase">
                </div>
             </div>
             <div class="form-group">
                <label class="col-sm-2 col-sm-2 control-label">SFTP Private Key (RSA)</label>
                <div class="col-sm-10">
                    <textarea name="sftp_key" class="form-control" placeholder="SFTP Private Key (RSA)" style="min-height: 150px;"></textarea>
                </div>
             </div>
         </div>
      </div>
      <div style="float: right; padding-right: 5px;">             
        <button type="submit" class="btn btn-success"><i class="fa fa-floppy-o"></i> Save</button>
      </div>
      
      <script>
        $("#ftp_type").val("'.$ftp_type.'");
        
        $("#ftp_type").change(function() {
            if(this.value == "ftp") {
                $("#sftp").hide();
                $("#ftp").show();
            }
            else
            {
                $("#ftp").hide();
                $("#sftp").show();           
            }
        });
        
        $("#sftp_login").change(function() {
            if(this.value == "password") {
                $("#sftp_key").hide();
                $("#sftp_password").show();
            }
            else
            {
                $("#sftp_password").hide();
                $("#sftp_key").show();           
            }
        });
      </script>
  </form>
</div>
';
?>