<?php
/*

Config file for Droppy premium plugin.
If you need support then please go to https://support.proxibolt.com

*/

require_once dirname(__FILE__) . '/../../config/config.php';
require_once dirname(__FILE__) . '/../../src/plugins/class.phpmailer.php';
require_once dirname(__FILE__) . '/../../src/plugins/class.smtp.php';

//Your table structure (Change before installing (If needed))
$table_pm_subs      = 'droppy_pm_subs';
$table_pm_users     = 'droppy_pm_users';
$table_pm_settings  = 'droppy_pm_settings';
$table_pm_forgot    = 'droppy_pm_forgot';
$table_pm_vouchers  = 'droppy_pm_vouchers';

//Turning sandbox mode on or off
$SandboxFlag = false; //true = Sanbox mode On | flase = Sanbox mode Off

//Time it takes before a suspended subscription gets canceled (When there is no activity when status is canceled)
$cancel_suspend = 604800; // 604800 (1 Week) default

//Getting the plugin settings from the database
$get_pm_settings = $mysqli->query("SELECT * FROM $table_pm_settings");
if($get_pm_settings->num_rows > 0) {
    while($settings = $get_pm_settings->fetch_assoc()) {
        $username_api               = $settings['username_api'];
        $password_api               = $settings['password_api'];
        $signature_api              = $settings['signature_api'];

        //Product settings
        $item_name                  = $settings['item_name'];
        $subscription_description   = $settings['subscription_desc'];
        $currency                   = $settings['currency'];
        $subscription_price         = $settings['sub_price'];
        $recurring_time             = $settings['recur_time'];
        $recurring_frequent         = $settings['recur_freq'];
        $max_failed_payments        = $settings['max_fails'];
        $pm_pass_enabled            = $settings['password_enabled'];
        $logo_paypal                = $settings['logo_url'];

        if(isset($_SESSION['droppy_premium'])) {
            $session_premium_email = $_SESSION['droppy_premium'];
            $get_sub_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE email='$session_premium_email' AND (status='active' OR status='canceled_end')");
            if($get_sub_info->num_rows > 0) {
                //Premium upload settings
                $max_size           = $settings['max_size'];
                $pm_pass_enabled    = 'true';
                $expire             = $settings['expire_time'];
                $ad_enabled         = $settings['ad_enabled'];
                if($ad_enabled == 'false') {
                    $ad_1_enabled = 'false';
                    $ad_2_enabled = 'false';
                }
            }
        }

        $sub_canceled_now_subject   = $settings['sub_cancel_n_subject'];
        $sub_canceled_now_email     = $settings['sub_cancel_n_email'];
        $sub_canceled_end_subject   = $settings['sub_cancel_e_subject'];
        $sub_canceled_end_email     = $settings['sub_cancel_e_email'];
        $new_sub_subject            = $settings['new_sub_subject'];
        $new_sub_email              = $settings['new_sub_email'];
        $suspended_email_subject    = $settings['sus_email_sub'];
        $suspended_email            = $settings['sus_email'];
        $payment_failed_subject     = $settings['payment_failed_sub'];
        $payment_failed_email       = $settings['payment_failed_email'];
        $forgot_password_subject    = $settings['forgot_pass_subject'];
        $forgot_password_email      = $settings['forgot_pass_email'];
    }
}

/*
=-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=
=-=-=-=-=-==-=-=-=-=-=Functions that are used by this plugin=-=-=-=-=-==-=-=-=-=-=
=-=-=-=-=-==-=-=-=-=-==-=-DO NOT CHANGE ANYTHING BELOW=-=-==-=-=-=-=-==-=-=-=-=-=-
=-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=-=-=-==-=-=
*/

function logPaypal($res_msg) {
	global $mysqli;
	global $table_log;

	$time = time();
	$insert = $mysqli->query("INSERT INTO $table_log (time,msg) VALUES ('$time','$res_msg');");
}
function change_subscription_status( $profile_id, $action, $type ) {
	global $username_api;
	global $password_api;
	global $signature_api;
	global $mysqli;
	global $table_pm_subs;
	global $SandboxFlag;
    global $sub_canceled_now_email;
    global $sub_canceled_now_subject;
    global $sub_canceled_end_email;
    global $sub_canceled_end_subject;
    global $site_url;

    $api_request = 'USER=' . urlencode($username_api)
                .  '&PWD=' . urlencode($password_api)
                .  '&SIGNATURE=' . urlencode($signature_api)
                .  '&VERSION=76.0'
                .  '&METHOD=ManageRecurringPaymentsProfileStatus'
                .  '&PROFILEID=' . urlencode( $profile_id )
                .  '&ACTION=' . urlencode( $action )
                .  '&NOTE=' . urlencode( 'Profile has been updated ['.$type.']' );
 
    $ch = curl_init();
    if($SandboxFlag == true) {
        curl_setopt( $ch, CURLOPT_URL, 'https://api-3t.sandbox.paypal.com/nvp' );
    }
    else
    {
        curl_setopt( $ch, CURLOPT_URL, 'https://api-3t.paypal.com/nvp' );
    }
    curl_setopt( $ch, CURLOPT_VERBOSE, 1 );
 
    // Uncomment these to turn off server and peer verification
    // curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, FALSE );
    // curl_setopt( $ch, CURLOPT_SSL_VERIFYHOST, FALSE );
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1 );
    curl_setopt( $ch, CURLOPT_POST, 1 );
 
    // Set the API parameters for this transaction
    curl_setopt( $ch, CURLOPT_POSTFIELDS, $api_request );
 
    // Request response from PayPal
    $response = curl_exec( $ch );
 
    // If no response was received from PayPal there is no point parsing the response
    if( ! $response )
        die( 'Calling PayPal to change_subscription_status failed: ' . curl_error( $ch ) . '(' . curl_errno( $ch ) . ')' );
 
    curl_close( $ch );
 
    // An associative array is more usable than a parameter string
    parse_str( $response, $parsed_response );
 	
    $get_sub = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$profile_id'");
    while($row = $get_sub->fetch_assoc()) {
        $sub_email = $row['email'];
        //Email shortcodes replacements
        $tokens = array(
            'next_date'     => date("Y-m-d", $row['next_date']),
            'paypal_id'     => $row['paypal_id'],
            'last_date'     => date("Y-m-d", $row['last_date']),
            'name'          => $row['name'],
            'status'        => $row['status'],
            'company'       => $row['company'],
            'sub_id'        => $row['sub_id'],
            'manage_page'   => $site_url . 'index.php?goto=customTab_Acc'
        );

        $pattern = '{%s}';
        
        $map = array();
        foreach($tokens as $var => $value)
        {
            $map[sprintf($pattern, $var)] = $value;
        }
    }

    if($action == 'Cancel') {
        if($type == 'now') {
            $email_message = strtr($sub_canceled_now_email, $map);
            sendSubMail($sub_email, $email_message, $sub_canceled_now_subject);
            $mysqli->query("UPDATE $table_pm_subs SET status='canceled' WHERE paypal_id='$profile_id'");
        }
        if($type == 'end') {
            $email_message = strtr($sub_canceled_end_email, $map);
            sendSubMail($sub_email, $email_message, $sub_canceled_end_subject);
            $mysqli->query("UPDATE $table_pm_subs SET status='canceled_end' WHERE paypal_id='$profile_id'");
        }
    }
    if($action == 'Reactivate') {
        //Account reactivated
    }

    return $parsed_response;
}
function sendSubMail($receiver, $message, $subject) {
    global $email_server;
    global $mail;
    global $email_from_name;
    global $email_from_email;
    global $site_url;
    global $theme_path;
    global $smtp_host;
    global $smtp_auth;
    global $smtp_secure;
    global $smtp_port;
    global $smtp_username;
    global $smtp_password;

    $template_email = '<html xmlns="http://www.w3.org/1999/xhtml">
        <head>
            <link href="' . $site_url . $theme_path . 'css/email.css" rel="stylesheet">
            <meta charset="utf-8"> 
        </head>
        <body bgcolor="#f6f6f6">
            <table class="body-wrap">
                <tr>
                    <td class="container" bgcolor="#FFFFFF">
                        <!-- content -->
                        <div class="content">
                        <table>
                            <tr>
                                <td>
                                    <div class="content">' . nl2br($message) . '</div>
                                </td>
                            </tr>
                        </table>
                        </div>
                        <!-- /content -->    
                    </td>
                </tr>
            </table>
        </body>
    </html>';

    if($email_server == 'SMTP') {
        //Sending the email to the sender of the file
        $mail             = new PHPMailer();

        $mail->IsSMTP(); // telling the class to use SMTP
        $mail->Host       = $smtp_host;
        $mail->SMTPAuth   = $smtp_auth;
        $mail->SMTPSecure = $smtp_secure;                       
        $mail->Port       = $smtp_port;                   
        $mail->Username   = $smtp_username;  
        $mail->Password   = $smtp_password; 

        $mail->From = $email_from_email;
        $mail->FromName = $email_from_name;

        $mail->AddReplyTo($email_from_email, $email_from_name);

        $mail->Subject    = $subject;

        $mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; // optional, comment out and test

        $mail->CharSet = 'UTF-8';
         
        $mail->MsgHTML($template_email);
         
        $mail->AddAddress($receiver);

        $mail->Send();
    }
    else
    {
        //Sending the email to the sender of the file
        $mail             = new PHPMailer();

        $mail->From = $email_from_email;
        $mail->FromName = $email_from_name;

        $mail->AddReplyTo($email_from_email, $email_from_name);

        $mail->Subject    = $subject;

        $mail->AltBody    = "To view the message, please use an HTML compatible email viewer!"; // optional, comment out and test

        $mail->CharSet = 'UTF-8';
         
        $mail->MsgHTML($template_email);
         
        $mail->AddAddress($receiver);

        $mail->Send();
    }
}
?>