<?php
/*

Action file for Premium plugin for Droppy online file sharing
By Proxibolt - Web development

*/

require_once dirname(__FILE__) . '/../config.php';

//Check if there is an action
if(isset($_POST['action'])) 
{
	//Check if the register function is called and validates password and terms
	if($_POST['action'] == 'register' && $_POST['password'] == $_POST['re_password'] && $_POST['terms'] == 'true') 
	{
		//Getting variables from the form
		$email = mysqli_real_escape_string($mysqli, $_POST['email']);
		$password = hash('sha512', $_POST['password']);
		$fullname = mysqli_real_escape_string($mysqli, $_POST['name']);
		$company = mysqli_real_escape_string($mysqli, $_POST['company']);
		$payment = mysqli_real_escape_string($mysqli, $_POST['payment']);
		$date = date("Y-m-d H:i:s");
		$time = time();
		$user_ip = $_SERVER['REMOTE_ADDR'];
		$_SESSION["original_url"] = $_POST['rd'];
		$_SESSION["subscription_id"] = md5(time() . rand());

		$get_user = $mysqli->query("SELECT * FROM $table_pm_users WHERE email='$email'");

        $voucher = mysqli_real_escape_string($mysqli, $_POST['voucher']);
        if(!empty($voucher)) {
            $get_voucher = $mysqli->query("SELECT * FROM $table_pm_vouchers WHERE code='$voucher'");
            //Check if exists
            if ($get_voucher->num_rows > 0) {
                $vouch = $get_voucher->fetch_assoc();

                if($vouch['discount_type'] == 'percentage') {
                    //calculate the discount price
                    $percentage = ($subscription_price * ($vouch['discount_percentage'] / 100));
                    $subscription_price = ($subscription_price - $percentage);
                }
                elseif($vouch['discount_type'] == 'value') {
                    //calculate the discount price
                    $subscription_price = ($subscription_price - $vouch['discount_value']);
                }

                if($subscription_price <= 0) {
                    $subscription_price = 0;
                    $payment = 'free';
                }
            }
        }

		//Checks if the user with $email already exists
		if($get_user->num_rows == 0) {
            $sub_id = $_SESSION['subscription_id'];

			//When the payment method is paypal
			if($payment == 'paypal') 
			{
				//Getting the paypal functions
				require_once ('gateway/paypal/paypalfunctions.php');

				//The price of the subscription
				$_SESSION["Payment_Amount"] = $subscription_price;

				//The payment type
				$paymentType = 'Sale';

				//Redirection URL when the payment has been successfully completed
				$returnURL = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']) . '/gateway/paypal/review.php';

				//When the payment is canceled by the user itself
				$cancelURL = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']) . '/action.php?action=paypal_payment_canceled';

				//Logo image path of paypal page
				$logoPath = $logo_paypal;

				//Sending information
				$resArray = CallShortcutExpressCheckout ($_SESSION['Payment_Amount'], $currency, $paymentType, $returnURL, $cancelURL, $logoPath);
				$ack = strtoupper($resArray["ACK"]);

				//When the payment information is correct
				if($ack=="SUCCESS" || $ack=="SUCCESSWITHWARNING")
				{
					$token = $resArray["TOKEN"];

					//Inserting the info into the database (This information is not validated yet so the user can not login yet) the review.php file will set the status of the users to ready
					$mysqli->query("INSERT INTO $table_pm_subs (sub_id,email,name,company,payment,time,status,paypal_token) VALUES ('$sub_id','$email','$fullname','$company','paypal','$time','validating','$token');");
					$mysqli->query("INSERT INTO $table_pm_users (email,password,ip,sub_id,status) VALUES ('$email','$password','$user_ip','$sub_id','ready');");
					logPaypal('[new_user] New user (' . $email . ') registered but payment is not validated yet.');

					RedirectToPayPal ( $token );
				} 
				else  
				{
					//Display a user friendly Error on the page using any of the following error information returned by PayPal
					$ErrorCode = urldecode($resArray["L_ERRORCODE0"]);
					$ErrorLongMsg = urldecode($resArray["L_LONGMESSAGE0"]);

					error_log($ErrorLongMsg);
				}
			}
            elseif($payment == 'free') {
                $mysqli->query("INSERT INTO $table_pm_subs (sub_id,email,name,company,payment,time,status,paypal_token,paypal_id) VALUES ('$sub_id','$email','$fullname','$company','free','$time','active','','$sub_id');");
                $mysqli->query("INSERT INTO $table_pm_users (email,password,ip,sub_id,status) VALUES ('$email','$password','$user_ip','$sub_id','ready');");

                //Email shortcodes replacements
                $get_info_email = $mysqli->query("SELECT * FROM $table_pm_subs WHERE sub_id='$sub_id'");
                while($row_email = $get_info_email->fetch_assoc()) {
                    $tokens = array(
                        'next_date'     => date("Y-m-d", $row_email['next_date']),
                        'paypal_id'     => $row_email['paypal_id'],
                        'last_date'     => date("Y-m-d", $row_email['last_date']),
                        'name'          => $row_email['name'],
                        'status'        => $row_email['status'],
                        'company'       => $row_email['company'],
                        'sub_id'        => $row_email['sub_id'],
                        'manage_page'   => $site_url . 'index.php?goto=customTab_Acc',
                        'email' 		=> $row_email['email'],
                        'payment' 		=> $row_email['payment'],
                        'amount' 		=> $subscription_price
                    );
                }

                $pattern = '{%s}';

                $map = array();
                foreach($tokens as $var => $value)
                {
                    $map[sprintf($pattern, $var)] = $value;
                }

                $email_message = strtr($new_sub_email, $map);
                sendSubMail($email, $email_message, $new_sub_subject);

                logPaypal("Free subscription with sub id (".$sub_id.") has been created");

                header('Location: ' . $_SESSION['original_url'] . '&payment=created');
            }
		}
		else
		{
			//User exists
		}
	}
	if($_POST['action'] == 'check_email') 
	{
		$postemail = $_POST['email'];

		if (!filter_var($postemail, FILTER_VALIDATE_EMAIL) === false) {
			$check_email = $mysqli->query("SELECT * FROM $table_pm_users WHERE email='$postemail'");
			if($check_email->num_rows == 0) 
			{
				echo 1;
			}
			else
			{
				echo 2;
			}
		}
		else
		{
			echo 3;
		}
	}
    if($_POST['action'] == 'check_voucher')
    {
        $voucher = strtoupper(mysqli_real_escape_string($mysqli, $_POST['voucher']));

        $check_vouch = $mysqli->query("SELECT * FROM $table_pm_vouchers WHERE code='$voucher'");
        if($check_vouch->num_rows == 0)
        {
            echo 0;
        }
        else
        {
            echo 1;
        }
    }
	if($_POST['action'] == 'login') 
	{
		$email 		= mysqli_real_escape_string($mysqli, $_POST['email']);
		$password 	= hash('sha512', $_POST['password']);

		$check_email = $mysqli->query("SELECT * FROM $table_pm_users WHERE email='$email'");
		if($check_email->num_rows == 1) 
		{
			while($row = $check_email->fetch_assoc()) {
				if($row['password'] == $password) {
					if($row['status'] == 'ready') {
						$_SESSION['droppy_premium'] = $row['email'];
						echo 1;
					}
					if($row['status'] == 'suspended_reversal') {
						$_SESSION['droppy_premium_suspend'] = $row['email'];
						echo 2;
					}
				}
				else
				{
					echo 0;
				}
			}
		}
		else
		{
			echo 0;
		}
	}
	if($_POST['action'] == 'forgot') 
	{
		$email 		= mysqli_real_escape_string($mysqli, $_POST['email']);

		$check_email = $mysqli->query("SELECT * FROM $table_pm_users WHERE email='$email'");
		if($check_email->num_rows == 1) 
		{
			$reset_code = hash('sha512', md5(rand() . time() . rand()));
			$mysqli->query("INSERT INTO $table_pm_forgot (email, reset) VALUES ('$email','$reset_code')");

			$tokens = array(
			    'reset_url'    	=> $site_url . 'index.php?goto=customTab_Acc&reset=' . $reset_code
			);

			$pattern = '{%s}';

			$map = array();
			foreach($tokens as $var => $value)
			{
			    $map[sprintf($pattern, $var)] = $value;
			}

			$email_message = strtr($forgot_password_email, $map);

			sendSubMail($email, $email_message, $forgot_password_subject);

			echo 1;
		}
		else
		{
			echo 0;
		}
	}
	if($_POST['action'] == 'reset_pass') 
	{
		$reset 		= mysqli_real_escape_string($mysqli, $_POST['reset']);
		$pass1 		= mysqli_real_escape_string($mysqli, $_POST['pass1']);
		$pass2 		= mysqli_real_escape_string($mysqli, $_POST['pass2']);

		$check_reset = $mysqli->query("SELECT * FROM $table_pm_forgot WHERE reset='$reset'");
		if($check_reset->num_rows == 1) 
		{
			while($row = $check_reset->fetch_assoc()) {
				$email = $row['email'];
				$new_pass = hash('sha512', $pass1);
				$mysqli->query("UPDATE $table_pm_users SET password='$new_pass' WHERE email='$email'");
				$mysqli->query("DELETE FROM $table_pm_forgot WHERE reset='$reset'");
				echo 1;
			}	
		}
		else
		{
			echo 0;
		}
	}
	if($_POST['action'] == 'change_details') 
	{
		$email 		= mysqli_real_escape_string($mysqli, $_POST['email']);
		$password 	= hash('sha512', $_POST['password']);
		$name 		= mysqli_real_escape_string($mysqli, $_POST['name']);
		$company 	= mysqli_real_escape_string($mysqli, $_POST['company']);
		$sub_id 	= mysqli_real_escape_string($mysqli, $_POST['sub_id']);

		$check_email = $mysqli->query("SELECT * FROM $table_pm_users WHERE email='$email'");
		$check_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE sub_id='$sub_id'");
		while($row = $check_info->fetch_assoc()) {
			if(!empty($email) || !empty($name) || !empty($sub_id)) {
				if($email != $row['email'] && $check_email->num_rows == 0 || $email == $row['email']) 
				{
					if(empty($_POST['password'])) {
						$mysqli->query("UPDATE $table_pm_subs SET email='$email', company='$company', name='$name' WHERE sub_id='$sub_id'");
						$mysqli->query("UPDATE $table_pm_users SET email='$email' WHERE sub_id='$sub_id'");
						$_SESSION['droppy_premium'] = $email;
						echo 1;
					}
					else
					{
						$mysqli->query("UPDATE $table_pm_subs SET email='$email', company='$company', name='$name' WHERE sub_id='$sub_id'");
						$mysqli->query("UPDATE $table_pm_users SET email='$email', password='$password' WHERE sub_id='$sub_id'");
						$_SESSION['droppy_premium'] = $email;
						echo 1;
					}
				}
				else
				{
					echo 2;
				}
			}
			else
			{
				echo 3;
			}
		}
	}
	if($_POST['action'] == 'add_sub') {
		$payment = mysqli_real_escape_string($mysqli, $_POST['payment']);
		$old_sub_id = mysqli_real_escape_string($mysqli, $_POST['sub_id']);
		$fullname = mysqli_real_escape_string($mysqli, $_POST['name']);
		$company = mysqli_real_escape_string($mysqli, $_POST['company']);
		$date = date("Y-m-d H:i:s");
		$time = time();
		$user_ip = $_SERVER['REMOTE_ADDR'];
		$_SESSION["original_url"] = $site_url . '?goto=customTab_Acc';

		$email = $_SESSION['droppy_premium'];
		$_SESSION["subscription_id"] = md5(time() . rand());
		$sub_id = $_SESSION["subscription_id"];

		$get_user_details = $mysqli->query("SELECT * FROM $table_pm_users");

        $voucher = mysqli_real_escape_string($mysqli, $_POST['voucher']);
        if(!empty($voucher)) {
            $get_voucher = $mysqli->query("SELECT * FROM $table_pm_vouchers WHERE code='$voucher'");
            //Check if exists
            if ($get_voucher->num_rows > 0) {
                $vouch = $get_voucher->fetch_assoc();

                if($vouch['discount_type'] == 'percentage') {
                    //calculate the discount price
                    $percentage = ($subscription_price * ($vouch['discount_percentage'] / 100));
                    $subscription_price = ($subscription_price - $percentage);
                }
                elseif($vouch['discount_type'] == 'value') {
                    //calculate the discount price
                    $subscription_price = ($subscription_price - $vouch['discount_value']);
                }

                if($subscription_price <= 0) {
                    $subscription_price = 0;
                    $payment = 'free';
                }
            }
        }

		//When the payment method is paypal
		if($payment == 'paypal') 
		{
			//Getting the paypal functions
			require_once ('gateway/paypal/paypalfunctions.php');

			//The price of the subscription
			$_SESSION["Payment_Amount"] = $subscription_price;

			//The currency of the product
			$currencyCodeType = $currency;

			//The payment type
			$paymentType = 'Sale';
			//$paymentType = "Authorization";
			//$paymentType = "Order";

			//Redirection URL when the payment has been successfully completed
			$returnURL = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']) . '/gateway/paypal/review.php';

			//When the payment is canceled by the user itself
			$cancelURL = 'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']) . '/action.php?action=paypal_payment_canceled';

			//Logo image path of paypal page
			$logoPath = $logo_paypal;

			//Sending information
			$resArray = CallShortcutExpressCheckout ($_SESSION['Payment_Amount'], $currencyCodeType, $paymentType, $returnURL, $cancelURL, $logoPath);
			$ack = strtoupper($resArray["ACK"]);

			//When the payment information is correct
			if($ack=="SUCCESS" || $ack=="SUCCESSWITHWARNING")
			{
				$token = $resArray["TOKEN"];

				//Inserting the info into the database (This information is not validated yet so the user can not login yet) the review.php file will set the status of the users to ready
				$mysqli->query("INSERT INTO $table_pm_subs (sub_id,email,name,company,payment,time,status,paypal_token,paypal_id) VALUES ('$sub_id','$email','$fullname','$company','paypal','$time','validating','$token');");
				$mysqli->query("UPDATE $table_pm_users SET sub_id='$sub_id' WHERE sub_id='$old_sub_id'");
				logPaypal('[new_subscription] New subscription added to user (' . $email . ') with new Sub. ID '.$sub_id);

				RedirectToPayPal ( $token );
			} 
			else  
			{
				//Display a user friendly Error on the page using any of the following error information returned by PayPal
				$ErrorCode = urldecode($resArray["L_ERRORCODE0"]);
				$ErrorLongMsg = urldecode($resArray["L_LONGMESSAGE0"]);

				logPaypal('[PAYPAL_ERROR] ' . $ErrorLongMsg);
			}
		}
        elseif($payment == 'free') {
            $mysqli->query("INSERT INTO $table_pm_subs (sub_id,email,name,company,payment,time,status,paypal_token,paypal_id) VALUES ('$sub_id','$email','$fullname','$company','free','$time','active','','$sub_id');");
            $mysqli->query("INSERT INTO $table_pm_users (email,password,ip,sub_id,status) VALUES ('$email','$password','$user_ip','$sub_id','ready');");

            //Email shortcodes replacements
            $get_info_email = $mysqli->query("SELECT * FROM $table_pm_subs WHERE sub_id='$sub_id'");
            while($row_email = $get_info_email->fetch_assoc()) {
                $tokens = array(
                    'next_date'     => date("Y-m-d", $row_email['next_date']),
                    'paypal_id'     => $row_email['paypal_id'],
                    'last_date'     => date("Y-m-d", $row_email['last_date']),
                    'name'          => $row_email['name'],
                    'status'        => $row_email['status'],
                    'company'       => $row_email['company'],
                    'sub_id'        => $row_email['sub_id'],
                    'manage_page'   => $site_url . 'index.php?goto=customTab_Acc',
                    'email' 		=> $row_email['email'],
                    'payment' 		=> $row_email['payment'],
                    'amount' 		=> $subscription_price
                );
            }

            $pattern = '{%s}';

            $map = array();
            foreach($tokens as $var => $value)
            {
                $map[sprintf($pattern, $var)] = $value;
            }

            $email_message = strtr($new_sub_email, $map);
            sendSubMail($email, $email_message, $new_sub_subject);

            logPaypal("Free subscription with sub id (".$sub_id.") has been created");

            header('Location: ' . $_SESSION['original_url'] . '&payment=created');
        }
	}
	if($_POST['action'] == 'settings_general' && isset($_SESSION['droppy_admin'])) {
		$new_username_api 		= mysqli_real_escape_string($mysqli, $_POST['username_api']);
		$new_password_api 		= mysqli_real_escape_string($mysqli, $_POST['password_api']);
		$new_signature_api 		= mysqli_real_escape_string($mysqli, $_POST['signature_api']);

		$new_item_name 			= mysqli_real_escape_string($mysqli, $_POST['item_name']);
		$new_sub_desc			= mysqli_real_escape_string($mysqli, $_POST['subscription_description']);
		$new_cur 				= mysqli_real_escape_string($mysqli, $_POST['currency']);
		$new_price 				= mysqli_real_escape_string($mysqli, $_POST['price']);
		$new_recur 				= mysqli_real_escape_string($mysqli, $_POST['recurring_time']);
		$new_freq 				= mysqli_real_escape_string($mysqli, $_POST['recurring_freq']);
		$new_fails 				= mysqli_real_escape_string($mysqli, $_POST['max_fails']);
		$new_max_size 			= mysqli_real_escape_string($mysqli, $_POST['max_size']);
		$new_pass_enabled		= mysqli_real_escape_string($mysqli, $_POST['password_enabled']);
		$new_expire 			= mysqli_real_escape_string($mysqli, $_POST['expire_time']);
		$new_ad_enabled 		= mysqli_real_escape_string($mysqli, $_POST['ad_enabled']);
		$new_logo_paypal 		= mysqli_real_escape_string($mysqli, $_POST['logo_paypal']);

		$new_cancel_now_sub 	= mysqli_real_escape_string($mysqli, $_POST['sub_cancel_n_subject']);
		$new_cancel_now_email 	= mysqli_real_escape_string($mysqli, $_POST['sub_cancel_n_email']);
		$new_cancel_end_sub 	= mysqli_real_escape_string($mysqli, $_POST['sub_cancel_e_subject']);
		$new_cancel_end_email 	= mysqli_real_escape_string($mysqli, $_POST['sub_cancel_e_email']);
		$new_sub_subject	 	= mysqli_real_escape_string($mysqli, $_POST['new_sub_subject']);
		$new_sub_email		 	= mysqli_real_escape_string($mysqli, $_POST['new_sub_email']);
		$new_sus_email_sub	 	= mysqli_real_escape_string($mysqli, $_POST['sus_email_sub']);
		$new_sus_email 			= mysqli_real_escape_string($mysqli, $_POST['sus_email']);
		$new_pay_failed_sub 	= mysqli_real_escape_string($mysqli, $_POST['payment_failed_sub']);
		$new_pay_failed_email 	= mysqli_real_escape_string($mysqli, $_POST['payment_failed_email']);
		$new_forgot_pass_sub 	= mysqli_real_escape_string($mysqli, $_POST['forgot_pass_sub']);
		$new_forgot_pass_email 	= mysqli_real_escape_string($mysqli, $_POST['forgot_pass_email']);
	
		$mysqli->query("UPDATE $table_pm_settings SET item_name='$new_item_name', subscription_desc='$new_sub_desc', currency='$new_cur', sub_price='$new_price', recur_time='$new_recur', recur_freq='$new_freq', max_fails='$new_fails', max_size='$new_max_size', password_enabled='$new_pass_enabled', expire_time='$new_expire', ad_enabled='$new_ad_enabled', username_api='$new_username_api', password_api='$new_password_api', signature_api='$new_signature_api', logo_url='$new_logo_paypal', sub_cancel_n_email='$new_cancel_now_email', sub_cancel_n_subject='$new_cancel_now_sub', sub_cancel_e_subject='$new_cancel_end_sub', sub_cancel_e_email='$new_cancel_end_email', new_sub_subject='$new_sub_subject', new_sub_email='$new_sub_email', sus_email_sub='$new_sus_email_sub', sus_email='$new_sus_email', payment_failed_sub='$new_pay_failed_sub', payment_failed_email='$new_pay_failed_email', forgot_pass_subject='$new_forgot_pass_sub', forgot_pass_email='$new_forgot_pass_email'");
		header('Location: '. $_POST['goback']);
	}
	if($_POST['action'] == 'delete_user' && isset($_SESSION['droppy_admin'])) {
		$id = mysqli_real_escape_string($mysqli, $_POST['id']);
		$return = $_POST['return'];

    	$mysqli->query("DELETE FROM $table_pm_users WHERE sub_id='$id'");

    	logPaypal('[subscription_canceled] User with Sub. id ('.$id.') has been deleted by admin.');

    	header('Location: ' . $return);
	}
	if($_POST['action'] == 'cancel_subscription' && isset($_SESSION['droppy_admin'])) {
		$id = mysqli_real_escape_string($mysqli, $_POST['id']);
		$return = $_POST['return'];

    	$get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE sub_id='$id'");
		while($row = $get_info->fetch_assoc()) {
            if($row['payment'] == 'free') {
                $mysqli->query("UPDATE $table_pm_subs SET status='canceled_end' WHERE id='".$row['id']."'");
            }
            else
            {
                change_subscription_status($row['paypal_id'], 'Cancel', $type);
                logPaypal('[subscription_canceled] Subscription (' . $id . ') has been canceled by admin.');
            }
    	}

    	header('Location: ' . $return);
	}
	if($_POST['action'] == 'activate_sub' && isset($_SESSION['droppy_admin'])) {
		$id = mysqli_real_escape_string($mysqli, $_POST['id']);
		$return = $_POST['return'];

    	$get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE sub_id='$id'");
		while($row = $get_info->fetch_assoc()) {
			$mysqli->query("UPDATE $table_pm_subs SET status='active' WHERE sub_id='$id'");
			change_subscription_status($row['paypal_id'], 'Reactivate', 'active_sus');
    		logPaypal('[subscription_canceled] Subscription ('.$id.') has been re-activated by admin.');
    	}

    	header('Location: ' . $return);
	}
    if($_POST['action'] == 'add_usersub' && isset($_SESSION['droppy_admin'])) {
        //Get post data
        $email          = mysqli_real_escape_string($mysqli, $_POST['email']);
        $fullname       = mysqli_real_escape_string($mysqli, $_POST['fullname']);
        $company_name   = mysqli_real_escape_string($mysqli, $_POST['company']);
        $password       = hash('sha512', $_POST['password']);
        $next_date      = strtotime($_POST['expiry']);
        $sub_id         = uniqid(); //Create unique id
        $date           = time(); //Get the current time.

        //Run queries
        $mysqli->query("INSERT INTO `$table_pm_users` (`email`, `password`, `ip`, `sub_id`, `status`) VALUES ('$email', '$password', '0.0.0.0', '$sub_id', 'ready');");
        $mysqli->query("INSERT INTO `$table_pm_subs` (`sub_id`, `email`, `name`, `company`, `payment`, `last_date`, `next_date`, `time`, `status`, `paypal_token`, `paypal_id`, `paypal_payerid`, `paypal_email`, `paypal_status`, `paypal_name`, `paypal_country`, `paypal_phone`, `paypal_ordertime`) VALUES ('$sub_id', '$email', '$fullname', '$company_name', 'free', '$date', '$next_date', '$date', 'active', '', '$sub_id', '', '$email', 'verified', '$fullname', 'US', '', '');");

        header('Location: '.$_POST['goback'] . '&p=subs');
    }
    if($_POST['action'] == 'add_voucher' && isset($_SESSION['droppy_admin'])) {
        //Get post data
        $code           = strtoupper(mysqli_real_escape_string($mysqli, $_POST['code']));
        $discount       = mysqli_real_escape_string($mysqli, $_POST['discount']);
        $discount_perc  = mysqli_real_escape_string($mysqli, $_POST['discount_percentage']);

        if(!empty($discount)) {
            //Discount value is set
            $discount_type = 'value';

            $mysqli->query("INSERT INTO $table_pm_vouchers (code,discount_type,discount_value,discount_percentage) VALUES ('$code','$discount_type','$discount','')");
        }
        elseif(!empty($discount_perc)) {
            //Discount percentage is set
            $discount_type = 'percentage';

            $mysqli->query("INSERT INTO $table_pm_vouchers (code,discount_type,discount_value,discount_percentage) VALUES ('$code','$discount_type','','$discount_perc')");
        }

        header('Location: '.$_POST['goback']);
    }
}

if(isset($_GET['action'])) 
{	//Checks if the checkout has been canceld
	if($_GET['action'] == 'paypal_payment_canceled') 
	{
		$token = mysqli_real_escape_string($mysqli, $_GET['token']);

		$get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_token='$token'");
      	while($row = $get_info->fetch_assoc()) 
      	{
        	$subid = $row['sub_id'];
        	$user_email = $row['email'];

        	$mysqli->query("UPDATE $table_pm_subs SET status='canceled' WHERE sub_id='$subid'");
        	$mysqli->query("DELETE FROM $table_pm_users WHERE sub_id='$subid' AND status='validating'");
        	logPaypal('[canceled_checkout] User (' . $user_email . ') with Sub. ID (' . $subid . ') canceled checkout');
        	logPaypal('[canceled_checkout] User (' . $user_email . ') with Sub. ID (' . $subid . ') has been removed');
        }

        //Redirect to cancel page
        header('Location: ' . $_SESSION['original_url'] . '&payment=canceled_user');
	}
	if($_GET['action'] == 'paypal_cancel') 
	{
		$id = mysqli_real_escape_string($mysqli, $_GET['id']);
		$type = mysqli_real_escape_string($mysqli, $_GET['type']);

    	$get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE sub_id='$id'");
		while($row = $get_info->fetch_assoc()) {
			change_subscription_status($row['paypal_id'], 'Cancel', $type);
    		logPaypal('[subscription_canceled] Subscription ('.$id.') has been canceled by user.');
    	}
    	header('Location: ../../../index.php?goto=customTab_Acc');
	}
    if($_GET['action'] == 'delete_voucher' && isset($_SESSION['droppy_admin'])) {
        $id = mysqli_real_escape_string($mysqli, $_GET['id']);

        $mysqli->query("DELETE FROM $table_pm_vouchers WHERE id='$id'");

        header('Location: '.$_SESSION['goback']);
    }
}
?>