<?php
require_once dirname(__FILE__) . '/../../../config.php';
require_once dirname(__FILE__) . '/paypalfunctions.php';

$raw_post_data = file_get_contents('php://input');
$raw_post_array = explode('&', $raw_post_data);
$myPost = array();
foreach ($raw_post_array as $keyval) {
  $keyval = explode ('=', $keyval);
  if (count($keyval) == 2)
     $myPost[$keyval[0]] = urldecode($keyval[1]);
}
// read the IPN message sent from PayPal and prepend 'cmd=_notify-validate'
$req = 'cmd=_notify-validate';
if(function_exists('get_magic_quotes_gpc')) {
   $get_magic_quotes_exists = true;
} 
foreach ($myPost as $key => $value) {        
   if($get_magic_quotes_exists == true && get_magic_quotes_gpc() == 1) { 
        $value = urlencode(stripslashes($value)); 
   } else {
        $value = urlencode($value);
   }
   $req .= "&$key=$value";
}

if($SandboxFlag == true) {
  $ch = curl_init('https://www.sandbox.paypal.com/cgi-bin/webscr');
}
else
{
  $ch = curl_init('https://www.paypal.com/cgi-bin/webscr');
}
curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
curl_setopt($ch, CURLOPT_POSTFIELDS, $req);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
curl_setopt($ch, CURLOPT_FORBID_REUSE, 1);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Connection: Close'));
// In wamp-like environments that do not come bundled with root authority certificates,
// please download 'cacert.pem' from "http://curl.haxx.se/docs/caextract.html" and set 
// the directory path of the certificate as shown below:
// curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__) . '/cacert.pem');
if( !($res = curl_exec($ch)) ) {
    // error_log("Got " . curl_error($ch) . " when processing IPN data");
    curl_close($ch);
    exit;
}
curl_close($ch);

$time = time();
// STEP 3: Inspect IPN validation result and act accordingly
if (strcmp ($res, "VERIFIED") == 0) {
  //Getting some information from the IPN post
  $txn_type = $_POST['txn_type'];
  $paypal_id = $_POST['recurring_payment_id'];

  //When payment has been reversed
  if(isset($_POST['payment_status'])) {
    if($_POST['payment_status'] == 'Reversed') 
    {
      $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
      while($row = $get_info->fetch_assoc()) 
      {
        $subid = $row['sub_id'];
        $user_email = $row['email'];
        $mysqli->query("UPDATE $table_pm_users SET status='suspended_reversal' WHERE sub_id='$subid'");
        $mysqli->query("UPDATE $table_pm_subs SET status='canceled' WHERE sub_id='$subid'");
        logPaypal('[reversed_payment] User (' . $user_email . ') has reversed subscription ('.$subid.')');
        logPaypal('[reversed_payment] User (' . $user_email . ') has been suspended due payment reversal');
        logPaypal('[reversed_payment] Subscription ('.$subid.') has been canceled due payment reversal');
      }
    }
    //When reversal has been canceled
    if($_POST['payment_status'] == 'Canceled_Reversal') 
    {
      $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
      while($row = $get_info->fetch_assoc()) 
      {
        $subid = $row['sub_id'];
        $user_email = $row['email'];
        $mysqli->query("UPDATE $table_pm_users SET status='ready' WHERE sub_id='$subid'");
        $mysqli->query("UPDATE $table_pm_subs SET status='active' WHERE sub_id='$subid'");
        logPaypal('[reversal_cancel] User\'s account (' . $user_email . ') has been released (Reversal has been canceled)');
        logPaypal('[reversal_cancel] Subscription ('.$subid.') is set to active (Reversal has been canceled)');
      }
    }
  }
  if($txn_type == 'recurring_payment') {
    if($_POST['payment_status'] == 'Completed') 
    {
      $resArray = GetRecurringPaymentsProfileDetails($paypal_id);
      $ack = strtoupper($resArray["ACK"]);

      if( $ack == "SUCCESS" || $ack == "SUCCESSWITHWARNING" )
      {
        //Getting the time in LA (California) (Paypal Timezone)
        date_default_timezone_set('America/Los_Angeles');

        if($recurring_time == 'Day') {
          $add_time = '86400';
        }
        if($recurring_time == 'Week') {
          $add_time = '604800';
        }
        if($recurring_time == 'Month') {
          $add_time = '2629743';
        }
        $nextbillingdate = time() + $add_time;
        $lastbillingdate = time();

        $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
        while($row = $get_info->fetch_assoc()) {
          $subid = $row['sub_id'];
          $mysqli->query("UPDATE $table_pm_users SET status='ready' WHERE sub_id='$subid'");
          $mysqli->query("UPDATE $table_pm_subs SET status='active', last_date='$lastbillingdate', next_date='$nextbillingdate' WHERE sub_id='$subid'");

          logPaypal('[recurring_payment] Payment for subscription ('.$subid.') has been received');
          logPaypal('[recurring_payment] Subscription ('.$subid.') has been extended to '.date("Y-m-d", $nextbillingdate));
        }
      }
      else
      {
        //Display a user friendly Error on the page using any of the following error information returned by PayPal
        $ErrorCode = urldecode($resArray["L_ERRORCODE0"]);
        $ErrorLongMsg = urldecode($resArray["L_LONGMESSAGE0"]);
        
        logPaypal('[PAYPAL_ERROR] ['.$ErrorCode.']'.$ErrorLongMsg);
      }
    }
  }
  //When subscription has been canceled
  if($txn_type == 'recurring_payment_profile_cancel') {
    $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
    while($row = $get_info->fetch_assoc()) {
      $subid = $row['sub_id'];
      if($row['status'] != 'canceled_end') {
        $mysqli->query("UPDATE $table_pm_users SET status='canceled', time='$time' WHERE sub_id='$subid'");
        $mysqli->query("UPDATE $table_pm_subs SET status='canceled_end', time='$time' WHERE sub_id='$subid'");

        $tokens = array(
            'next_date'     => date("Y-m-d", $row['next_date']),
            'paypal_id'     => $row['paypal_id'],
            'last_date'     => date("Y-m-d", $row['last_date']),
            'name'          => $row['name'],
            'status'        => $row['status'],
            'company'       => $row['company'],
            'sub_id'        => $row['sub_id'],
            'manage_page'   => $site_url . 'index.php?goto=customTab_Acc'
        );

        $pattern = '{%s}';
        
        $map = array();
        foreach($tokens as $var => $value)
        {
            $map[sprintf($pattern, $var)] = $value;
        }

        $email_message = strtr($sub_canceled_end_email, $map);
        sendSubMail($row['email'], $email_message, $sub_canceled_end_subject);
      }

      logPaypal('[recurring_payment_profile_cancel] Subscription (' . $subid . ') with Paypal ID (' . $paypal_id . ') has been canceled due cancelation by customer');   
    }
  }
  //When the subscription is missing payments
  if($txn_type == 'recurring_payment_skipped') {
    $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
    while($row = $get_info->fetch_assoc()) {
      $subid = $row['sub_id'];
        
      $tokens = array(
            'next_date'     => date("Y-m-d", $row['next_date']),
            'paypal_id'     => $row['paypal_id'],
            'last_date'     => date("Y-m-d", $row['last_date']),
            'name'          => $row['name'],
            'status'        => $row['status'],
            'company'       => $row['company'],
            'sub_id'        => $row['sub_id'],
            'manage_page'   => $site_url . 'index.php?goto=customTab_Acc'
      );

      $pattern = '{%s}';
      
      $map = array();
      foreach($tokens as $var => $value)
      {
          $map[sprintf($pattern, $var)] = $value;
      }

      $email_message = strtr($payment_failed_email, $map);
      sendSubMail($row['email'], $email_message, $payment_failed_subject);

      logPaypal('[recurring_payment_skipped] Account with Sub. ID (' . $subid . ') and paypal ID ' . $paypal_id . ' has received a skipped payment, a message to the user has been sent.');    
    }
  }
  //When the subscription is missing payments
  if($txn_type == 'recurring_payment_failed') {
    $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
    while($row = $get_info->fetch_assoc()) {
      $subid = $row['sub_id'];

      $tokens = array(
            'next_date'     => date("Y-m-d", $row['next_date']),
            'paypal_id'     => $row['paypal_id'],
            'last_date'     => date("Y-m-d", $row['last_date']),
            'name'          => $row['name'],
            'status'        => $row['status'],
            'company'       => $row['company'],
            'sub_id'        => $row['sub_id'],
            'manage_page'   => $site_url . 'index.php?goto=customTab_Acc'
      );

      $pattern = '{%s}';
      
      $map = array();
      foreach($tokens as $var => $value)
      {
          $map[sprintf($pattern, $var)] = $value;
      }

      $email_message = strtr($payment_failed_email, $map);
      sendSubMail($row['email'], $email_message, $payment_failed_subject);

      logPaypal('[recurring_payment_failed] Account with Sub. ID (' . $subid . ') and paypal ID ' . $paypal_id . ' has received a failed payment, a message has been sent to the user.'); 
    }
  }
  //When the subscription is missing payments
  if($txn_type == 'recurring_payment_suspended_due_to_max_failed_payment') {
    $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
    while($row = $get_info->fetch_assoc()) {
      $subid = $row['sub_id'];
      $mysqli->query("UPDATE $table_pm_users SET status='suspended', time='$time' WHERE sub_id='$subid'");
      $mysqli->query("UPDATE $table_pm_subs SET status='suspended', time='$time' WHERE sub_id='$subid'");

      $tokens = array(
            'next_date'     => date("Y-m-d", $row['next_date']),
            'paypal_id'     => $row['paypal_id'],
            'last_date'     => date("Y-m-d", $row['last_date']),
            'name'          => $row['name'],
            'status'        => $row['status'],
            'company'       => $row['company'],
            'sub_id'        => $row['sub_id'],
            'manage_page'   => $site_url . 'index.php?goto=customTab_Acc'
      );

      $pattern = '{%s}';
      
      $map = array();
      foreach($tokens as $var => $value)
      {
          $map[sprintf($pattern, $var)] = $value;
      }

      $email_message = strtr($suspended_email, $map);
      sendSubMail($row['email'], $email_message, $suspended_email_subject);

      logPaypal('[recurring_payment_suspended_due_to_max_failed_payment] Account with Sub. ID (' . $subid . ') and paypal ID ' . $paypal_id . ' has been suspended due to many failed payment(s).'); 
    }
  }
  if($txn_type == 'recurring_payment_suspended') {
    $get_info = $mysqli->query("SELECT * FROM $table_pm_subs WHERE paypal_id='$paypal_id'");
    while($row = $get_info->fetch_assoc()) {
      $subid = $row['sub_id'];
      $mysqli->query("UPDATE $table_pm_users SET status='suspended', time='$time' WHERE sub_id='$subid'");
      $mysqli->query("UPDATE $table_pm_subs SET status='suspended', time='$time' WHERE sub_id='$subid'");

      $tokens = array(
            'next_date'     => date("Y-m-d", $row['next_date']),
            'paypal_id'     => $row['paypal_id'],
            'last_date'     => date("Y-m-d", $row['last_date']),
            'name'          => $row['name'],
            'status'        => $row['status'],
            'company'       => $row['company'],
            'sub_id'        => $row['sub_id'],
            'manage_page'   => $site_url . 'index.php?goto=customTab_Acc'
      );

      $pattern = '{%s}';
      
      $map = array();
      foreach($tokens as $var => $value)
      {
          $map[sprintf($pattern, $var)] = $value;
      }

      $email_message = strtr($suspended_email, $map);
      sendSubMail($row['email'], $email_message, $suspended_email_subject);

      logPaypal('[recurring_payment_suspended] Account with Sub. ID (' . $subid . ') and paypal ID ' . $paypal_id . ' has been suspended. The profile has been suspended using Paypal.'); 
    }
  }
} else if (strcmp ($res, "INVALID") == 0) {
    // IPN invalid, log for manual investigation
    logPaypal('[PAYPAL_ERROR] Paypal could not connect to IPN response is INVALID, ');
}
?>